/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/wireformat/openwire/marshal/generated/TransactionInfoMarshaller.h>

#include <activemq/commands/TransactionInfo.h>
#include <activemq/exceptions/ActiveMQException.h>
#include <decaf/lang/Pointer.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::commands;
using namespace activemq::wireformat;
using namespace activemq::wireformat::openwire;
using namespace activemq::wireformat::openwire::marshal;
using namespace activemq::wireformat::openwire::utils;
using namespace activemq::wireformat::openwire::marshal::generated;
using namespace decaf;
using namespace decaf::io;
using namespace decaf::lang;

///////////////////////////////////////////////////////////////////////////////
DataStructure* TransactionInfoMarshaller::createObject() const {
    return new TransactionInfo();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char TransactionInfoMarshaller::getDataStructureType() const {
    return TransactionInfo::ID_TRANSACTIONINFO;
}

///////////////////////////////////////////////////////////////////////////////
void TransactionInfoMarshaller::tightUnmarshal(OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs) {

    try {

        BaseCommandMarshaller::tightUnmarshal(wireFormat, dataStructure, dataIn, bs);

        TransactionInfo* info =
            dynamic_cast<TransactionInfo*>(dataStructure);
        info->setConnectionId(Pointer<ConnectionId>(dynamic_cast<ConnectionId* >(
            tightUnmarshalCachedObject(wireFormat, dataIn, bs))));
        info->setTransactionId(Pointer<TransactionId>(dynamic_cast<TransactionId* >(
            tightUnmarshalCachedObject(wireFormat, dataIn, bs))));
        info->setType(dataIn->readByte());
    }
    AMQ_CATCH_RETHROW(decaf::io::IOException)
    AMQ_CATCH_EXCEPTION_CONVERT(exceptions::ActiveMQException, decaf::io::IOException)
    AMQ_CATCHALL_THROW(decaf::io::IOException)
}

///////////////////////////////////////////////////////////////////////////////
int TransactionInfoMarshaller::tightMarshal1(OpenWireFormat* wireFormat, DataStructure* dataStructure, BooleanStream* bs) {

    try {

        TransactionInfo* info =
            dynamic_cast<TransactionInfo*>(dataStructure);

        int rc = BaseCommandMarshaller::tightMarshal1(wireFormat, dataStructure, bs);
        rc += tightMarshalCachedObject1(wireFormat, info->getConnectionId().get(), bs);
        rc += tightMarshalCachedObject1(wireFormat, info->getTransactionId().get(), bs);

        return rc + 1;
    }
    AMQ_CATCH_RETHROW(decaf::io::IOException)
    AMQ_CATCH_EXCEPTION_CONVERT(exceptions::ActiveMQException, decaf::io::IOException)
    AMQ_CATCHALL_THROW(decaf::io::IOException)
}

///////////////////////////////////////////////////////////////////////////////
void TransactionInfoMarshaller::tightMarshal2(OpenWireFormat* wireFormat, DataStructure* dataStructure, DataOutputStream* dataOut, BooleanStream* bs) {

    try {

        BaseCommandMarshaller::tightMarshal2(wireFormat, dataStructure, dataOut, bs );

        TransactionInfo* info =
            dynamic_cast<TransactionInfo*>(dataStructure);
        tightMarshalCachedObject2(wireFormat, info->getConnectionId().get(), dataOut, bs);
        tightMarshalCachedObject2(wireFormat, info->getTransactionId().get(), dataOut, bs);
        dataOut->write(info->getType());
    }
    AMQ_CATCH_RETHROW(decaf::io::IOException)
    AMQ_CATCH_EXCEPTION_CONVERT( exceptions::ActiveMQException, decaf::io::IOException)
    AMQ_CATCHALL_THROW(decaf::io::IOException)
}

///////////////////////////////////////////////////////////////////////////////
void TransactionInfoMarshaller::looseUnmarshal(OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn) {

    try {

        BaseCommandMarshaller::looseUnmarshal(wireFormat, dataStructure, dataIn);
        TransactionInfo* info =
            dynamic_cast<TransactionInfo*>(dataStructure);
        info->setConnectionId(Pointer<ConnectionId>(dynamic_cast<ConnectionId*>(
            looseUnmarshalCachedObject(wireFormat, dataIn))));
        info->setTransactionId(Pointer<TransactionId>(dynamic_cast<TransactionId*>(
            looseUnmarshalCachedObject(wireFormat, dataIn))));
        info->setType(dataIn->readByte());
    }
    AMQ_CATCH_RETHROW(decaf::io::IOException)
    AMQ_CATCH_EXCEPTION_CONVERT(exceptions::ActiveMQException, decaf::io::IOException)
    AMQ_CATCHALL_THROW(decaf::io::IOException)
}

///////////////////////////////////////////////////////////////////////////////
void TransactionInfoMarshaller::looseMarshal(OpenWireFormat* wireFormat, DataStructure* dataStructure, DataOutputStream* dataOut) {

    try {

        TransactionInfo* info =
            dynamic_cast<TransactionInfo*>(dataStructure);
        BaseCommandMarshaller::looseMarshal(wireFormat, dataStructure, dataOut);
        looseMarshalCachedObject(wireFormat, info->getConnectionId().get(), dataOut);
        looseMarshalCachedObject(wireFormat, info->getTransactionId().get(), dataOut);
        dataOut->write(info->getType());
    }
    AMQ_CATCH_RETHROW(decaf::io::IOException)
    AMQ_CATCH_EXCEPTION_CONVERT(exceptions::ActiveMQException, decaf::io::IOException)
    AMQ_CATCHALL_THROW(decaf::io::IOException)
}

